import { NativeEventEmitter, NativeModules } from 'react-native';
const {
  IONPortalsPubSub,
  IONPortalManager
} = NativeModules;
export { default as PortalView } from './PortalView';
const PortalsPubSub = new NativeEventEmitter(IONPortalsPubSub);
let subscriptionRefDict = {};
export const subscribe = async (topic, onMessageReceived) => {
  const subscriptionRef = await IONPortalsPubSub.subscribe(topic);
  subscriptionRefDict[subscriptionRef] = PortalsPubSub.addListener('PortalsSubscription', onMessageReceived);
  return subscriptionRef;
};
export const unsubscribe = (topic, subRef) => {
  IONPortalsPubSub.unsubscribe(topic, subRef);
  subscriptionRefDict[subRef] = null;
};
export const publish = (topic, data) => {
  const msg = {
    message: data
  };
  IONPortalsPubSub.publish(topic, msg);
};
export const register = key => {
  IONPortalManager.register(key);
};
export const addPortal = portal => {
  IONPortalManager.addPortal(portal);
};
//# sourceMappingURL=index.js.map